/* ccgo: settings.cc
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef SETTINGS_HH
#define SETTINGS_HH
#include <string>
#include <gconfmm/client.h>
namespace go
{
	class Settings
	{
		Glib::RefPtr<Gnome::Conf::Client> client;

		static const std::string main_path;
		static const int version_serial;

		bool dump_igs;
		bool leak_raw;
		bool pop_players_on_tell;
		bool pop_players_on_stats;
		bool pop_players_on_match;

		bool show_coordinate;
		bool picture_stone;
		bool picture_board;

		std::string image_path;
		std::string igs_telnet;
	public:
		enum Options {
			OPT_DUMP_IGS,
			OPT_LEAK_RAW,
			OPT_POP_PLAYERS_ON_TELL,
			OPT_POP_PLAYERS_ON_STATS,
			OPT_POP_PLAYERS_ON_MATCH,
			OPT_SHOW_COORDINATE,
			OPT_PICTURE_STONE,
			OPT_PICTURE_BOARD
		};

		Settings();
		void init();
		void command_line(int, char * [], char * []);

		const std::string get_string(const std::string &);
		void set_string(const std::string &, const std::string &);

		int get_int(const std::string &);
		void set_int(const std::string &, int);

		bool get_option(Options);
		void set_option(Options, bool);

		const std::string & get_image_path();
		void set_image_path(const std::string &);

		const std::string & get_igs_telnet();
		void set_igs_telnet(const std::string &);
	};

	extern Settings settings;
}
#endif // SETTINGS_HH
